package io.gitlab.jfronny.dynres;

import io.gitlab.jfronny.libjf.Libjf;
import io.gitlab.jfronny.libweb.api.LibWebAPI;
import io.gitlab.jfronny.libweb.api.LibWebInit;
import net.fabricmc.api.EnvType;
import net.fabricmc.loader.api.FabricLoader;
import net.fabricmc.loader.gui.FabricGuiEntry;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;

public class DynRes implements LibWebInit {
    public static File resFile;
    public static String resourceLink = "";

    static {
        Libjf.registerConfig("dynres", Cfg.class);
        resFile = new File(FabricLoader.getInstance().getGameDir().toFile(), Cfg.resourcesFile);
        if (!resFile.isFile()) {
            FabricGuiEntry.displayCriticalError(new FileNotFoundException("The file " + resFile + " does not exist in the game directory but is required"), true);
        }
    }

    @Override
    public void register(LibWebAPI api) {
        if (FabricLoader.getInstance().getEnvironmentType() == EnvType.SERVER) {
            try {
                resourceLink = api.registerFile("/resources.zip", resFile.toPath(), !Cfg.hashResources);
                Logger.l.info("Initialized DynRes at " + resourceLink);
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }
}
